﻿Type=StaticCode
Version=5.8
ModulesStructureVersion=1
B4J=true
@EndOfDesignText@
'Static code module
Sub Process_Globals
	Type  TDataLineValues(LineOut As String, BoxNumber As String, ComicTitle As String, Issue As String, Qty As String, CoverPrice As String, SellingPrice As String, OverUnder As String, CoverValue As String, SellingValue As String)
	
	Private fx As JFX
	
	Private LookForText()					As String   = Array As String("comic title", "issue number", 	"quantity in stock", 	"cover price", 	"selling price", "box number", "", "")
	Private LookForTextChangeTo()			As String   = Array As String("", 			 "Issue",			"Qty", 					"", 			"",				 "",		   "", "")
	
	Private CONST_LookFor_ComicTitle		As Int		=  0
	Private CONST_LookFor_Issue				As Int		=  1
	Private CONST_LookFor_Qty				As Int		=  2
	Private CONST_LookFor_CoverPrice		As Int		=  3
	Private CONST_LookFor_SellingPrice		As Int		=  4
	Private CONST_LookFor_BoxNumber			As Int		=  5
'	Private CONST_LookFor_QtyValue			As Int		=  6
'	Private CONST_LookFor_ValueOver			As Int		=  7
	Public  CONST_LookFor_Entries			As Int		=  8
	
	Private mHeaderLine						As TDataLineValues
	Private mCombinedHeaderLine				As TDataLineValues
	
	Private mEntriesAt(LookForText.Length) 	As Int					
End Sub


Public  Sub ProcessHeader(LineIn As String) As String
			For i = 0 To mEntriesAt.Length-1
				mEntriesAt(i) = -1
			Next
	
			If  LineIn <> Null Then
				Dim Temp		As String
				Dim StrArray() 	As String = Regex.Split("\" &TAB &"", LineIn)
	
				For i = 0 To LookForText.Length-1
					For j = 0 To StrArray.Length-1
						Temp = StrArray(j).ToLowerCase

						If  Temp.EqualsIgnoreCase(LookForText(i)) Then
							mEntriesAt(i) = j
					
							If  LookForTextChangeTo(i).Length <> 0 Then
								LineIn = LineIn.Replace(StrArray(j), LookForTextChangeTo(i))
							End If
					
							Exit
						End If
					Next
				Next
			End If

			mHeaderLine.Initialize
			mCombinedHeaderLine.Initialize
			
			If  HaveAll Then
'				Dim LineOut			As String
				Dim BoxNumber		As String
				Dim ComicTitle		As String
				Dim Issue			As String
				Dim Qty				As String
				Dim CoverPrice		As String
				Dim SellingPrice	As String
			
				Dim StrArray() 		As String = Regex.Split("\" &TAB &"", LineIn)
	
				BoxNumber 							= StrArray(mEntriesAt(CONST_LookFor_BoxNumber))
				ComicTitle				 			= StrArray(mEntriesAt(CONST_LookFor_ComicTitle))
				Issue				 				= StrArray(mEntriesAt(CONST_LookFor_Issue))
				Qty					 				= StrArray(mEntriesAt(CONST_LookFor_Qty))
				CoverPrice 							= StrArray(mEntriesAt(CONST_LookFor_CoverPrice))
				SellingPrice 						= StrArray(mEntriesAt(CONST_LookFor_SellingPrice))
			
				mHeaderLine.LineOut					= BoxNumber &TAB &ComicTitle &TAB &Issue &TAB &Qty &TAB &CoverPrice &TAB &SellingPrice &TAB &"Over / Under" &Chr(13) &Chr(10)
				mHeaderLine.BoxNumber		 		= BoxNumber
				mHeaderLine.ComicTitle				= ComicTitle
				mHeaderLine.Issue					= Issue
				mHeaderLine.Qty						= Qty
				mHeaderLine.CoverPrice				= CoverPrice
				mHeaderLine.SellingPrice			= SellingPrice
				mHeaderLine.CoverValue				= "Total Cover"
				mHeaderLine.SellingValue			= "Total Selling"				
				mHeaderLine.OverUnder				= "Over / Under"
				
				mCombinedHeaderLine.LineOut			= "Titles" &TAB &"# Issues" &TAB &"Total Cover" &TAB &"Total Selling" &TAB &"Over / Under" &Chr(13) &Chr(10)							
				mCombinedHeaderLine.ComicTitle		= "Titles"
				mCombinedHeaderLine.Issue			= "Issue"
				mCombinedHeaderLine.Qty				= "# Issues"
				mCombinedHeaderLine.CoverValue		= "Total Cover"
				mCombinedHeaderLine.SellingValue	= "Total Selling"
				mCombinedHeaderLine.OverUnder		= "Over / Under"				
			End If
			
			Return LineIn
End Sub

#Region Have checks
Public  Sub HaveAll As Boolean
			If  HaveBoxNumber And HaveComicTitle And HaveIssue And HaveQty And HaveCoverPrice And HaveSellingPrice Then Return True
			
			Return False	
End Sub

Public  Sub HaveBoxNumber As Boolean
			If  mEntriesAt(CONST_LookFor_BoxNumber) <> -1 Then Return True
			
			Return False
End Sub

Public  Sub HaveComicTitle As Boolean
			If  mEntriesAt(CONST_LookFor_ComicTitle) <> -1 Then Return True
			
			Return False
End Sub

Public  Sub HaveIssue As Boolean
			If  mEntriesAt(CONST_LookFor_Issue) <> -1 Then Return True
			
			Return False
End Sub

Public  Sub HaveQty As Boolean
			If  mEntriesAt(CONST_LookFor_Qty) <> -1 Then Return True
			
			Return False
End Sub

Public  Sub HaveCoverPrice As Boolean
			If  mEntriesAt(CONST_LookFor_CoverPrice) <> -1 Then Return True
	
			Return False
End Sub

Public  Sub HaveSellingPrice As Boolean
			If  mEntriesAt(CONST_LookFor_SellingPrice) <> -1 Then Return True
	
			Return False
End Sub
#end Region

Public  Sub HeaderLine As TDataLineValues
	
			Return mHeaderLine
End Sub

Public  Sub CombinedHeaderLine As TDataLineValues
	
			Return mCombinedHeaderLine
End Sub


Public  Sub ReformatLine(LineIn As String, DataValues As TDataLineValues) As String

			Dim LineOut			As String
			Dim BoxNumber		As String
			Dim ComicTitle		As String
			Dim Issue			As String
			Dim Qty				As String
			Dim CoverPrice		As String
			Dim SellingPrice	As String
			
			Dim LineValues		As TDataLineValues
			
			Dim StrArray() 		As String = Regex.Split("\" &TAB &"", LineIn)

			LineValues.Initialize
				
			BoxNumber 		= StrArray(mEntriesAt(CONST_LookFor_BoxNumber))
			ComicTitle 		= StrArray(mEntriesAt(CONST_LookFor_ComicTitle))
			Issue 			= StrArray(mEntriesAt(CONST_LookFor_Issue))
			Qty 			= StrArray(mEntriesAt(CONST_LookFor_Qty))
			CoverPrice 		= StrArray(mEntriesAt(CONST_LookFor_CoverPrice))
			SellingPrice 	= StrArray(mEntriesAt(CONST_LookFor_SellingPrice))
			
			LineValues.BoxNumber	= BoxNumber
			LineValues.ComicTitle	= ComicTitle
			LineValues.Issue		= Issue
						
			If  IsNumber(Qty) Then
				LineValues.Qty		= Qty
				
				Dim QtyValue 		As Double = 0										
				Dim SellingValue 	As Double = 0

				If  IsNumber(CoverPrice) Then
					QtyValue 				= Qty * CoverPrice
					
					LineValues.CoverPrice	= CoverPrice
					LineValues.CoverValue	= QtyValue					
				End If
					
				If  IsNumber(SellingPrice) Then
					SellingValue 			= Qty * SellingPrice
					
					LineValues.SellingPrice	= SellingPrice
					LineValues.SellingValue = SellingValue
				End If
			End If
				
			If  DataValues.IsInitialized = False Then DataValues.Initialize
			
			DataValues.BoxNumber	= 	LineValues.BoxNumber
			DataValues.ComicTitle	= 	LineValues.ComicTitle
			DataValues.Issue		= 	LineValues.Issue
			DataValues.Qty			=	LineValues.Qty
			DataValues.CoverPrice	=	LineValues.CoverPrice
			DataValues.SellingPrice =	LineValues.SellingPrice
			DataValues.CoverValue	=	LineValues.CoverValue
			DataValues.SellingValue =	LineValues.SellingValue
			DataValues.OverUnder	=   LineValues.SellingValue - LineValues.CoverValue
			
			LineOut = BoxNumber &TAB &ComicTitle &TAB &Issue &TAB &Qty &TAB &CoverPrice &TAB &SellingPrice &TAB &NumberFormat((SellingValue - QtyValue), 2, 2) &Chr(13) &Chr(10)
				
			Return LineOut
End Sub

Public  Sub ReformatLineCombined(Title As String, Issues As String, TotalCover As String, TotalPrice As String, OverUnder As String, CombinedDataLineValues As TDataLineValues) As String

			Dim LineOut			As String			
						
						
			If  CombinedDataLineValues.IsInitialized = False Then CombinedDataLineValues.Initialize
			
			CombinedDataLineValues.ComicTitle	= 	Title
			CombinedDataLineValues.Qty			=	Issues
			CombinedDataLineValues.CoverValue	=	TotalCover
			CombinedDataLineValues.SellingValue =	TotalPrice
			CombinedDataLineValues.OverUnder	=   OverUnder
			
			LineOut = Title &TAB &Issues &TAB &TotalCover &TAB &TotalPrice &TAB &OverUnder &Chr(13) &Chr(10)
				
			Return LineOut
End Sub
							
'
Public  Sub SetDataLength(WorkSheetInfo As TPoiWorkSheetInfo, Entry As Int, Data As String)

			Dim ColWidth As Int = WorkSheetInfo.MaxColWidths.Get(Entry)
			
'Log("Sheet:" &WorkSheetInfo.WorkSheet.Name &"  Column:" &Entry &"  ColWidth:" &ColWidth &"  Data Lenghth:" &Data.Length  &"  Data:" &Data)
			
'		
'		If  Row = 0 And Doing = CONST_LookFor_ComicTitle Then
'			Dim DataOut As String = Data(i) &"'s for box " &WorkSheetInfo.WorkSheet.Name
'			
'			If  DataOut.Length >= ColWidth Then
'				ColWidth 		= DataOut.Length
'			
'				WorkSheetInfo.MaxColWidths.Set(i, DataOut.Length)
'			End If			
'		Else
			Dim Temp As String = Data

			Temp	= Temp.Trim

			If  Temp.Length >= ColWidth Or ColWidth = 0 Then
				
				ColWidth 		= Temp.Length
			
				WorkSheetInfo.MaxColWidths.Set(Entry, Temp.Length)
				
				ColWidth = ColWidth + 10				
			End If
'		End If
		
					
		WorkSheetInfo.WorkSheet.SetColumnWidth(Entry, (ColWidth * 256))	
End Sub