﻿Type=StaticCode
Version=5.8
ModulesStructureVersion=1
B4J=true
@EndOfDesignText@
'Static code module
Sub Process_Globals
	Type  TPoiWorkSheetInfo(WorkSheet As PoiSheet, MaxColWidths As List)	
	
	Private fx As JFX
	
	Public  Const  CONST_Margin_Left				As Short	=	0
	Public  Const  CONST_Margin_Right				As Short	=	1
	Public  Const  CONST_Margin_Top					As Short	=	2
	Public  Const  CONST_Margin_Bottom				As Short	=	3
	Public  Const  CONST_Margin_Header				As Short	=	4
	Public  Const  CONST_Margin_Footer				As Short	=	5
	
	Private Bold_LeftJust							As PoiCellStyle
	Private Bold_Center								As PoiCellStyle
	Private Bold_RightJust							As PoiCellStyle

	Private Normal_LeftJust							As PoiCellStyle
	Private Normal_Center							As PoiCellStyle
	Private Normal_RightJust						As PoiCellStyle

	Private Normal_LeftJust_WholeNumber				As PoiCellStyle
	Private Normal_Center_WholeNumber				As PoiCellStyle
	Private Normal_RightJust_WholeNumber			As PoiCellStyle

	Private Normal_LeftJust_Decimals				As PoiCellStyle
	Private Normal_Center_Decimals					As PoiCellStyle
	Private Normal_RightJust_Decimals				As PoiCellStyle
			
End Sub


#Region GetMargin, SetMargin, SetMargins
'Margin: 0 = Left, 1 = Right, 2 = Top, 3 = Bottom, 4 = Header, 5 = Footer
Public  Sub GetMargin(Sheet As PoiSheet, Margin As Short) As Double
			Dim jo As JavaObject = Sheet
			Return jo.RunMethod("getMargin", Array(Margin))
End Sub


Public  Sub SetMargin(Sheet As PoiSheet, Margin As Short, Size As Double)
			Dim jo As JavaObject = Sheet

			jo.RunMethod("setMargin", Array(Margin, Size))
End Sub

Public  Sub SetMargins(Sheet As PoiSheet, left As Double, top As Double, right As Double, bottom As Double)
			Dim jo As JavaObject = Sheet
	
			jo.RunMethod("setMargin", Array(CONST_Margin_Left, 		left))
			jo.RunMethod("setMargin", Array(CONST_Margin_Top, 		top))
			jo.RunMethod("setMargin", Array(CONST_Margin_Right, 	right))
			jo.RunMethod("setMargin", Array(CONST_Margin_Bottom, 	bottom))	
End Sub
#end Region

#Region SetHeaderCenter
Public  Sub SetHeaderCenter(WorkBook As PoiWorkbook, Sheet As PoiSheet, Text As String, Landscape As Boolean, Scale As Short)
			Dim sheetJo 	As JavaObject = Sheet			
			
			Dim header 		As JavaObject = sheetJo.RunMethod("getHeader", Null)
			Dim page		As JavaObject = sheetJo.RunMethod("getPrintSetup", Null)
			
			Dim cellrange 	As JavaObject

			page.RunMethod("setLandscape", Array(Landscape))
			
			If  Scale = 0 Then
				Scale = 100
			End If
			
			page.RunMethod("setScale", Array(Scale))
			
			header.RunMethod("setLeft", Array("&""Arial,Bold""&14&D&B"))
			header.RunMethod("setCenter", Array("&""Arial,Bold""&16" &Text &"&B"))
			header.RunMethod("setRight", Array("&""Arial,Bold""&14Page &P"  &" of " &"&N&B"))				

			cellrange = cellrange.InitializeStatic("org.apache.poi.ss.util.CellRangeAddress").RunMethod("valueOf", Array("$1:$1"))

			sheetJo.RunMethod("setRepeatingRows", Array(cellrange))
End Sub
#end Region

#Region SheetPhysicalRows
Public  Sub SheetPhysicalRows(Sheet As PoiSheet) As Int
			Dim jo As JavaObject = Sheet
	
			Return jo.RunMethod("getPhysicalNumberOfRows",Null)	
End Sub
#end Region

#Region AutoSizeColumn
Public  Sub AutoSizeColumn(Sheet As PoiSheet, Column As Int)
			Dim jo As JavaObject = Sheet
	
			jo.RunMethod("autoSizeColumn", Array(Column))	
End Sub
#end Region

#Region trackColumnForAutoSizing
Public  Sub TrackColumnForAutoSizing(Sheet As PoiSheet, Column As Int)
			Dim jo As JavaObject = Sheet
	
			jo.RunMethod("trackColumnForAutoSizing", Array(Column))	
End Sub
#end Region

#Region FreezeTopRow
Public  Sub FreezeTopRow(Sheet As PoiSheet)
			Dim jo As JavaObject = Sheet
	
			jo.RunMethod("createFreezePane", Array(0, 1))	
End Sub
#End Region

#Region SetSheetOrder
Public  Sub SetSheetOrder(WorkBook As PoiWorkbook, SheetName As String, NewOrder As Int)
			Dim jo As JavaObject = WorkBook
	
			jo.RunMethod("setSheetOrder", Array(SheetName, NewOrder))	
End Sub
#end Region

#Region SetActiveSheet
Public  Sub SetActiveSheet(WorkBook As PoiWorkbook, SheetNum As Int)

			Dim jo As JavaObject = WorkBook
	
			jo.RunMethod("setActiveSheet", Array(SheetNum))		
			jo.RunMethod("setSelectedTab", Array(SheetNum))					
End Sub
#end Region

#Region CreateStyleLines
Public	Sub CreateStyleLines(WorkBook As PoiWorkbook)

			Dim Bold_Font		As PoiFont
			Dim Normal_Font  	As PoiFont

			Bold_Font.Initialize(WorkBook)
			Bold_Font.Size 	= 12
			Bold_Font.Name 	= "Arial"			
			Bold_Font.Bold	= True			
			Bold_Font.SetColor(fx.Colors.Black)

			Normal_Font.Initialize(WorkBook)
			Normal_Font.Size 	= 12
			Normal_Font.Name 	= "Arial"			
			Normal_Font.Bold	= False			
			Normal_Font.SetColor(fx.Colors.Black)

			Bold_LeftJust.Initialize(WorkBook)			
			Bold_LeftJust.ForegroundColor 			= fx.Colors.LightGray
			Bold_LeftJust.HorizontalAlignment 		= Bold_LeftJust.HORIZONTAL_LEFT
			Bold_LeftJust.SetFont(Bold_Font)
			SetStyle(False, Bold_LeftJust)

			Bold_Center.Initialize(WorkBook)			
			Bold_Center.ForegroundColor 			= fx.Colors.LightGray
			Bold_Center.HorizontalAlignment 		= Bold_Center.HORIZONTAL_CENTER
			Bold_Center.SetFont(Bold_Font)
			SetStyle(False, Bold_Center)
			
			Bold_RightJust.Initialize(WorkBook)			
			Bold_RightJust.ForegroundColor 			= fx.Colors.LightGray
			Bold_RightJust.HorizontalAlignment	 	= Bold_RightJust.HORIZONTAL_RIGHT
			Bold_RightJust.SetFont(Bold_Font)
			SetStyle(False, Bold_RightJust)
			
			
			Normal_LeftJust.Initialize(WorkBook)			
			Normal_LeftJust.ForegroundColor 		= fx.Colors.White
			Normal_LeftJust.HorizontalAlignment 	= Normal_LeftJust.HORIZONTAL_LEFT
			Normal_LeftJust.SetFont(Normal_Font)
			SetStyle(False, Normal_LeftJust)

			Normal_Center.Initialize(WorkBook)			
			Normal_Center.ForegroundColor 			= fx.Colors.White
			Normal_Center.HorizontalAlignment 		= Normal_Center.HORIZONTAL_CENTER
			Normal_Center.SetFont(Normal_Font)
			SetStyle(False, Normal_Center)
			
			Normal_RightJust.Initialize(WorkBook)			
			Normal_RightJust.ForegroundColor 		= fx.Colors.White
			Normal_RightJust.HorizontalAlignment 	= Normal_RightJust.HORIZONTAL_RIGHT
			Normal_RightJust.SetFont(Normal_Font)
			SetStyle(False, Normal_RightJust)

			Normal_LeftJust_WholeNumber.Initialize(WorkBook)			
			Normal_LeftJust_WholeNumber.ForegroundColor 		= fx.Colors.White
			Normal_LeftJust_WholeNumber.HorizontalAlignment 	= Normal_LeftJust_WholeNumber.HORIZONTAL_LEFT
			Normal_LeftJust_WholeNumber.SetFont(Normal_Font)
			SetStyle(False, Normal_LeftJust_WholeNumber)

			Normal_Center_WholeNumber.Initialize(WorkBook)			
			Normal_Center_WholeNumber.ForegroundColor 			= fx.Colors.White
			Normal_Center_WholeNumber.HorizontalAlignment 		= Normal_Center_WholeNumber.HORIZONTAL_CENTER
			Normal_Center_WholeNumber.SetFont(Normal_Font)
			SetStyle(False, Normal_Center_WholeNumber)
			
			Normal_RightJust_WholeNumber.Initialize(WorkBook)			
			Normal_RightJust_WholeNumber.ForegroundColor 		= fx.Colors.White
			Normal_RightJust_WholeNumber.HorizontalAlignment 	= Normal_RightJust_WholeNumber.HORIZONTAL_RIGHT
			Normal_RightJust_WholeNumber.SetFont(Normal_Font)
			SetStyle(False, Normal_RightJust_WholeNumber)

			Normal_LeftJust_Decimals.Initialize(WorkBook)			
			Normal_LeftJust_Decimals.ForegroundColor 		= fx.Colors.White
			Normal_LeftJust_Decimals.HorizontalAlignment 	= Normal_LeftJust_Decimals.HORIZONTAL_LEFT
			Normal_LeftJust_Decimals.SetFont(Normal_Font)
			SetStyle(False, Normal_LeftJust_Decimals)

			Normal_Center_Decimals.Initialize(WorkBook)			
			Normal_Center_Decimals.ForegroundColor 			= fx.Colors.White
			Normal_Center_Decimals.HorizontalAlignment 		= Normal_Center_Decimals.HORIZONTAL_CENTER
			Normal_Center_Decimals.SetFont(Normal_Font)
			SetStyle(False, Normal_Center_Decimals)
			
			Normal_RightJust_Decimals.Initialize(WorkBook)			
			Normal_RightJust_Decimals.ForegroundColor 		= fx.Colors.White
			Normal_RightJust_Decimals.HorizontalAlignment 	= Normal_RightJust_Decimals.HORIZONTAL_RIGHT
			Normal_RightJust_Decimals.SetFont(Normal_Font)
			SetStyle(False, Normal_RightJust_Decimals)
End Sub
#end Region

#Region SetStyle
Private Sub SetStyle(Medium As Boolean, Style As PoiCellStyle)
			If  Medium Then
				Style.BorderBottom = Style.BORDER_MEDIUM
				Style.BorderTop	   = Style.BORDER_MEDIUM
				Style.BorderLeft   = Style.BORDER_MEDIUM
				Style.BorderRight  = Style.BORDER_MEDIUM
			Else
				Style.BorderBottom = Style.BORDER_THIN
				Style.BorderTop	   = Style.BORDER_THIN
				Style.BorderLeft   = Style.BORDER_THIN
				Style.BorderRight  = Style.BORDER_THIN
			End If
End Sub
#end Region

#Region StyleLine
Public  Sub StyleLine(Bold As Boolean, LeftJust As Boolean, Center As Boolean, RightJust As Boolean, Text As Boolean, Decimals As Boolean, WrapText As Boolean) As PoiCellStyle
			
			Dim  Style As PoiCellStyle = Normal_LeftJust
			
			If  Bold Then
				If  LeftJust 		Then 
					Style = Bold_LeftJust
				Else if Center 		Then 
					Style = Bold_Center
				else if RightJust	Then 
					Style = Bold_RightJust				
				End If
			Else if Text Then
				If  LeftJust 		Then 
					Style = Normal_LeftJust
				Else If  Center		Then 
					Style = Normal_Center
				Else if RightJust	Then 
					Style = Normal_RightJust				
				End If
			Else 
				If  Decimals Then
					If  LeftJust 		Then 
						Style = Normal_LeftJust_Decimals
					Else If  Center 	Then 
						Style = Normal_Center_Decimals
					else If  RightJust	Then 
						Style = Normal_RightJust_Decimals
					End If
				Else 
					If  LeftJust 		Then 
						Style = Normal_LeftJust_WholeNumber
					Else If  Center 	Then 
						Style = Normal_Center_WholeNumber
					else If  RightJust	Then 
						Style = Normal_RightJust_WholeNumber											
					End If
				End If
			End If
			
			Style.WrapText = WrapText
			
			Return Style
End Sub
#end Region


#if  __CouldNotGetShiftRows_ToWork__
#Region ShiftRows
Public  Sub ShiftRows(Sheet As PoiSheet, StartRow As Int, EndRow As Int, DirectionAmt As Int)
	
			Dim jo As JavaObject = Sheet
	
			jo.RunMethod("shiftRows", Array(StartRow, EndRow, DirectionAmt))		
End Sub
#end Region


#Region SortSheetByColumn
Public  Sub SortSheetByColumn(Sheet As PoiSheet, ColumnToSort As Int, Ascending As Boolean, HasHeaders As Boolean)
	
'Return				
			Dim  Sorting 	As Boolean 		= True
			
			Dim  JO			As JavaObject	= Sheet
			Dim  LastRow	As Int			= Sheet.LastRowNumber
			Dim  RowNum		As Int
			
			Dim  Cmp1		As String
			Dim  Cmp2		As String
			
			Dim  Row		As PoiRow
			Dim  Row2		As PoiRow
			

			Log("Sort Sheet:" &Sheet.Name)
			
'#if xxx			
			For RowNum = 0 To LastRow-1
				Row 	= Sheet.GetRow(RowNum)
				
				If  Row.IsInitialized = False Then 
					Row = JO.RunMethod("getRow", Array(RowNum))		
				End If
			
				If  Row.IsInitialized = False Then Continue
					
				Cmp1 = Row.GetCell(ColumnToSort).ValueString
					
				Log("RowNum:" &RowNum &"   Cmp1:" &Cmp1)				
			Next
'#end if			

			
			Do 	While(Sorting)
				Sorting = False
				
				For RowNum = 0 To LastRow-1
					If  HasHeaders And RowNum = 0 	Then Continue

					Row 	= Sheet.GetRow(RowNum)
					
					If  Row.IsInitialized = False Then Continue
					
					Row2	= Sheet.GetRow(Row.RowNumber+1)
					
					If  Row2.IsInitialized = False Then Continue
					
					Cmp1 = Row.GetCell(ColumnToSort).ValueString.ToLowerCase
					Cmp2 = Row2.GetCell(ColumnToSort).ValueString.ToLowerCase
					
					Log("RowNum:" &RowNum &"   Cmp1:" &Cmp1 &"  Row2Num:" &Row2.RowNumber &"  Cmp2:" &Cmp2)
					
					If  Cmp2.CompareTo(Cmp1) < 0 Then
						Log("Cmp2 < Cmp1")
						ShiftRows(Sheet, Row2.RowNumber, Row2.RowNumber, -1)
						ShiftRows(Sheet, Row.RowNumber,	 Row.RowNumber,	  1)
						
						Sorting = True
					End If
				Next
			Loop
			
'Private void sortSheet(Sheet Sheet, int column, int rowStart) {
'    boolean Sorting = true;
'    int LastRow = Sheet.getLastRowNum();
'    While (Sorting == True) {
'        Sorting = false;
'        For (Row Row : Sheet) {
'            // skip If this Row Is before first To Sort
'            If (Row.getRowNum()<rowStart) continue;
'            // End If this Is last Row
'            If (LastRow==Row.getRowNum()) break;
'            Row Row2 = Sheet.getRow(Row.getRowNum()+1);
'            If (Row2 == Null) continue;
'            String firstValue = (Row.getCell(column) != Null) ? Row.getCell(column).getStringCellValue() : "";
'            String secondValue = (Row2.getCell(column) != Null) ? Row2.getCell(column).getStringCellValue() : "";
'            //compare cell from current Row And Next Row - And switch If secondValue should be before first
'            If (secondValue.compareToIgnoreCase(firstValue)<0) {                    
'                Sheet.shiftRows(Row2.getRowNum(), Row2.getRowNum(), -1);
'                Sheet.shiftRows(Row.getRowNum(), Row.getRowNum(), 1);
'                Sorting = true;
'            }
'        }
'    }
'}	
End Sub
#end Region
#end if
